#property copyright "    @Kobzar1112"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrBlue
#property indicator_color2 clrRed
#property indicator_width1 1
#property indicator_width2 1
//============================================
enum ON_OFF {
             on, //ON
             off //OFF
             };
enum BEAR_BULL_OFF {
             uBull_dBear, //UP-, DOWN-
             uBear_dBull, //UP-, DOWN-
             none //
             };
enum TYPE_SIGN {
             in,      //  
             out,     //  
             tick_in, //   
             tick_out //   
             };
enum TYPE_LINE_STOCH {
             total,   // 
             no_total // 
             };
enum TYPE_TIME { 
             en_time, //  
             dis_time //  
             };
enum TYPE_MAIL { 
             one_time, //      
             all_time  //    
             };
//============================================
extern string             txt0         = "~~~~~~   1 ~~~~~~"; //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
extern ON_OFF             on_off_main1 = on;                  // 
extern string             name_ind1    = "WerlipIndicator-final";        //  
extern int                bufferUP1    = 0;                   //   ""
extern int                bufferDN1    = 1;                   //   ""
extern string             txt01        = "";                  //.
extern string             txt02        = "~~~~~~   2 ~~~~~~"; //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
extern ON_OFF             on_off_main2 = on;                  // 
extern string             name_ind2    = "$_NVC Light_new";        //  
extern int                bufferUP2    = 1;                   //   ""
extern int                bufferDN2    = 0;                   //   ""
extern string             txt012       = "";                  //.
extern string             txt29        = "";                  //.
extern int                ots          = 15;                  //    ( )
extern ON_OFF             AlertSound   = 1;                 //  
extern string             txt30        = "";                  //.
extern ON_OFF             AlertMail    = 1;                 //    E-mail
extern ON_OFF             AlertNotif   = 1;                 //    .
extern TYPE_MAIL          mail_type    = 0;                   //      ...

double buyBuffer[];
double sellBuffer[];

bool   indicatorsON=true;
int time_cnt = 0;
bool soundBuy = false;
bool soundSell = false;
bool sendMail = true;
datetime timeBar = iTime(NULL,0,0);
datetime timeBar_prev = iTime(NULL,0,0);
double rollback_bar;

int init()
{
// Buffers and style
SetIndexStyle(0, DRAW_ARROW);
SetIndexArrow(0, 225);
SetIndexBuffer(0, buyBuffer);
SetIndexStyle(1, DRAW_ARROW);
SetIndexArrow(1, 226);
SetIndexBuffer(1, sellBuffer);
// Data window
IndicatorShortName("4343");

if(true&&true&&
true&&
true&&true&&true&&
true&&
true&&
true&&
true&&
true&&true&&true&&
true&&true&&
true&&true&&
true&&true&&
on_off_main1==1&&on_off_main2==1&&true) indicatorsON=false;

 return(INIT_SUCCEEDED);
}

int deinit()
{
 Comment("");
 return(0);
}

int start()
{
 if(indicatorsON) Tick();
 return(0);
}

void Tick()
  {
      double gap  = ots*Point;

    int limit;
    int counted_bars = IndicatorCounted();
    if(counted_bars < 0) 
        return;
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;

    for(int i = 0; i < limit; i++)
     {   
      if(false||false||false) continue;

       // Long signal
      if(BuySell_signal("buy",i))
       buyBuffer[i] = Low[i]-gap;
       else
       buyBuffer[i] = EMPTY_VALUE;

        // Short signal
      if(BuySell_signal("sell",i))
       sellBuffer[i] = High[i]+gap;
       else
       sellBuffer[i] = EMPTY_VALUE;
        }

        string  messageBuy  =  StringConcatenate("4343 (", Symbol(), ", ", Period(), ")  -  BUY!!!" ,"-" ,TimeToStr(TimeLocal(),TIME_SECONDS));
        string  messageSell =  StringConcatenate("4343 (", Symbol(), ", ", Period(), ")  -  SELL!!!","-"  ,TimeToStr(TimeLocal(),TIME_SECONDS));
     if(mail_type==0)
     {timeBar = iTime(NULL,0,0);
      if (timeBar_prev!=timeBar) sendMail = true;
      timeBar_prev = iTime(NULL,0,0);}

     if (buyBuffer[0] == Low[0]-gap && soundBuy)
         {
           soundBuy = false;
           if(AlertSound==0) Alert(messageBuy);
          if(sendMail)
           {sendMail = false;
            if(AlertNotif==0) SendNotification(messageBuy);
            if(AlertMail==0)  SendMail("4343",messageBuy);}
          }
      if (!soundBuy && (buyBuffer[0] == EMPTY_VALUE)) {soundBuy = true;  if(mail_type==1) sendMail = true;}
     if (sellBuffer[0] == High[0]+gap && soundSell)
         {
           soundSell = false;
           if(AlertSound==0) Alert(messageSell);
          if(sendMail)
           {sendMail = false;
            if(AlertNotif==0) SendNotification(messageSell);
            if(AlertMail==0)  SendMail("4343",messageSell);}
          }
      if (!soundSell && (sellBuffer[0] == EMPTY_VALUE)) {soundSell = true;  if(mail_type==1) sendMail = true;}

}

bool BuySell_signal(string b_s, int i)
 {
     if(b_s=="buy")
       // Long signal
      {if(
true
          &&
true
          &&
         (on_off_main1==1 || fun_main1("up",i))
          &&
         (on_off_main2==1 || fun_main2("up",i))
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
         )
       return(true);
       else
       return(false);}

     if(b_s=="sell")
        // Short signal
      {if(
true
          &&
true
          &&
         (on_off_main1==1 || fun_main1("dn",i))
          &&
         (on_off_main2==1 || fun_main2("dn",i))
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
          &&
true
         )
       return(true);
       else
       return(false);}
    return(false);
  }

bool fun_main1 (string up_dn, int index)
 {
  double _b = EMPTY_VALUE;
  double _s = EMPTY_VALUE;

                    _b = iCustom(NULL, 0, name_ind1, bufferUP1, index);
                    _s = iCustom(NULL, 0, name_ind1, bufferDN1, index);
                     if(up_dn=="up")
                        {
                         if( _b!=EMPTY_VALUE && _b!=0 ) return(true); else return(false);
                         }
                     if(up_dn=="dn")
                        {
                         if( _s!=EMPTY_VALUE && _s!=0 ) return(true); else return(false);
                         }
  return(false);
  }

bool fun_main2 (string up_dn, int index)
 {
  double _b = EMPTY_VALUE;
  double _s = EMPTY_VALUE;

                    _b = iCustom(NULL, 0, name_ind2, bufferUP2, index);
                    _s = iCustom(NULL, 0, name_ind2, bufferDN2, index);
                     if(up_dn=="up")
                        {
                         if( _b!=EMPTY_VALUE && _b!=0 ) return(true); else return(false);
                         }
                     if(up_dn=="dn")
                        {
                         if( _s!=EMPTY_VALUE && _s!=0 ) return(true); else return(false);
                         }
  return(false);
  }

